3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 USAGE='(--continue | --abort | --skip | [--preserve-merges] [--verbose]
14 [--onto <branch>] <upstream> [<branch>])'
20 DOTEST="$GIT_DIR/.dotest-merge"
21 TODO="$DOTEST"/git-rebase-todo
24 SQUASH_MSG="$DOTEST"/message-squash
25 REWRITTEN="$DOTEST"/rewritten
29 test -d "$REWRITTEN" && PRESERVE_MERGES=t
30 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
31 test -f "$DOTEST"/verbose && VERBOSE=t
33 GIT_CHERRY_PICK_HELP=" After resolving the conflicts,
34 mark the corrected paths with 'git add <paths>', and
35 run 'git rebase --continue'"
36 export GIT_CHERRY_PICK_HELP
47 test $status != 0 && printf "%s\n" "$output"
56 require_clean_work_tree () {
57 # test if working tree is dirty
58 git rev-parse --verify HEAD > /dev/null &&
59 git update-index --refresh &&
60 git diff-files --quiet &&
61 git diff-index --cached --quiet HEAD -- ||
62 die "Working tree is dirty"
65 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
67 comment_for_reflog () {
68 case "$ORIG_REFLOG_ACTION" in
70 GIT_REFLOG_ACTION="rebase -i ($1)"
71 export GIT_REFLOG_ACTION
78 sed -e 1q < "$TODO" >> "$DONE"
79 sed -e 1d < "$TODO" >> "$TODO".new
80 mv -f "$TODO".new "$TODO"
81 count=$(($(grep -ve '^$' -e '^#' < "$DONE" | wc -l)))
82 total=$(($count+$(grep -ve '^$' -e '^#' < "$TODO" | wc -l)))
83 if test "$last_count" != "$count"
86 printf "Rebasing (%d/%d)\r" $count $total
87 test -z "$VERBOSE" || echo
92 parent_sha1=$(git rev-parse --verify "$1"^) ||
93 die "Cannot get patch for $1^"
94 git diff-tree -p "$parent_sha1".."$1" > "$DOTEST"/patch
95 test -f "$DOTEST"/message ||
96 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
97 test -f "$DOTEST"/author-script ||
98 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
113 grep -vqe '^$' -e '^#' "$1"
118 case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
119 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
120 test -d "$REWRITTEN" &&
121 pick_one_preserving_merges "$@" && return
122 parent_sha1=$(git rev-parse --verify $sha1^) ||
123 die "Could not get the parent of $sha1"
124 current_sha1=$(git rev-parse --verify HEAD)
125 if test "$no_ff$current_sha1" = "$parent_sha1"; then
126 output git reset --hard $sha1
127 test "a$1" = a-n && output git reset --soft $current_sha1
128 sha1=$(git rev-parse --short $sha1)
129 output warn Fast forward to $sha1
131 output git cherry-pick "$@"
135 pick_one_preserving_merges () {
136 case "$1" in -n) sha1=$2 ;; *) sha1=$1 ;; esac
137 sha1=$(git rev-parse $sha1)
139 if test -f "$DOTEST"/current-commit
141 current_commit=$(cat "$DOTEST"/current-commit) &&
142 git rev-parse HEAD > "$REWRITTEN"/$current_commit &&
143 rm "$DOTEST"/current-commit ||
144 die "Cannot write current commit's replacement sha1"
147 # rewrite parents; if none were rewritten, we can fast-forward.
151 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -f2-)
153 if test -f "$REWRITTEN"/$p
156 new_p=$(cat "$REWRITTEN"/$p)
157 test $p != $new_p && fast_forward=f
158 case "$new_parents" in
160 ;; # do nothing; that parent is already there
162 new_parents="$new_parents $new_p"
167 case $fast_forward in
169 output warn "Fast forward to $sha1"
170 test $preserve = f || echo $sha1 > "$REWRITTEN"/$sha1
173 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
175 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
176 # detach HEAD to current parent
177 output git checkout $first_parent 2> /dev/null ||
178 die "Cannot move HEAD to $first_parent"
180 echo $sha1 > "$DOTEST"/current-commit
181 case "$new_parents" in
184 author_script=$(get_author_ident_from_commit $sha1)
185 eval "$author_script"
186 msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
187 # No point in merging the first parent, that's HEAD
188 new_parents=${new_parents# $first_parent}
189 if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
190 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
191 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
192 output git merge $STRATEGY -m "$msg" \
196 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
197 die Error redoing merge $sha1
201 output git cherry-pick "$@" ||
202 die_with_patch $sha1 "Could not pick $sha1"
211 *1[0-9]|*[04-9]) echo "$1"th;;
218 make_squash_message () {
219 if test -f "$SQUASH_MSG"; then
220 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
221 < "$SQUASH_MSG" | tail -n 1)+1))
222 echo "# This is a combination of $COUNT commits."
223 sed -e 1d -e '2,/^./{
228 echo "# This is a combination of two commits."
229 echo "# The first commit's message is:"
231 git cat-file commit HEAD | sed -e '1,/^$/d'
234 echo "# This is the $(nth_string $COUNT) commit message:"
236 git cat-file commit $1 | sed -e '1,/^$/d'
239 peek_next_command () {
240 sed -n "1s/ .*$//p" < "$TODO"
244 rm -f "$DOTEST"/message "$DOTEST"/author-script \
245 "$DOTEST"/amend || exit
246 read command sha1 rest < "$TODO"
252 comment_for_reflog pick
256 die_with_patch $sha1 "Could not apply $sha1... $rest"
259 comment_for_reflog edit
263 die_with_patch $sha1 "Could not apply $sha1... $rest"
267 warn "You can amend the commit now, with"
269 warn " git commit --amend"
271 warn "Once you are satisfied with your changes, run"
273 warn " git rebase --continue"
278 comment_for_reflog squash
280 has_action "$DONE" ||
281 die "Cannot 'squash' without a previous commit"
284 make_squash_message $sha1 > "$MSG"
285 case "$(peek_next_command)" in
289 cp "$MSG" "$SQUASH_MSG"
294 rm -f "$SQUASH_MSG" || exit
299 author_script=$(get_author_ident_from_commit HEAD)
300 output git reset --soft HEAD^
301 pick_one -n $sha1 || failed=t
302 echo "$author_script" > "$DOTEST"/author-script
305 # This is like --amend, but with a different message
306 eval "$author_script"
307 GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
308 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
309 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
310 $USE_OUTPUT git commit --no-verify -F "$MSG" $EDIT_COMMIT || failed=t
314 cp "$MSG" "$GIT_DIR"/MERGE_MSG
316 warn "Could not apply $sha1... $rest"
317 die_with_patch $sha1 ""
321 warn "Unknown command: $command $sha1 $rest"
322 die_with_patch $sha1 "Please fix this in the file $TODO."
325 test -s "$TODO" && return
327 comment_for_reflog finish &&
328 HEADNAME=$(cat "$DOTEST"/head-name) &&
329 OLDHEAD=$(cat "$DOTEST"/head) &&
330 SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
331 if test -d "$REWRITTEN"
333 test -f "$DOTEST"/current-commit &&
334 current_commit=$(cat "$DOTEST"/current-commit) &&
335 git rev-parse HEAD > "$REWRITTEN"/$current_commit
336 if test -f "$REWRITTEN"/$OLDHEAD
338 NEWHEAD=$(cat "$REWRITTEN"/$OLDHEAD)
343 NEWHEAD=$(git rev-parse HEAD)
347 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
348 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
349 git symbolic-ref HEAD $HEADNAME
352 test ! -f "$DOTEST"/verbose ||
353 git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
357 warn "Successfully rebased and updated $HEADNAME."
373 comment_for_reflog continue
375 test -d "$DOTEST" || die "No interactive rebase running"
378 git rev-parse --verify HEAD >/dev/null ||
379 die "Cannot read HEAD"
380 git update-index --refresh && git diff-files --quiet ||
381 die "Working tree is dirty"
383 # do we have anything to commit?
384 if git diff-index --cached --quiet HEAD --
386 : Nothing to commit -- skip this
388 . "$DOTEST"/author-script ||
389 die "Cannot find the author identity"
390 if test -f "$DOTEST"/amend
392 git reset --soft HEAD^ ||
393 die "Cannot rewind the HEAD"
395 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
396 git commit --no-verify -F "$DOTEST"/message -e ||
397 die "Could not commit staged changes."
400 require_clean_work_tree
404 comment_for_reflog abort
407 test -d "$DOTEST" || die "No interactive rebase running"
409 HEADNAME=$(cat "$DOTEST"/head-name)
410 HEAD=$(cat "$DOTEST"/head)
413 git symbolic-ref HEAD $HEADNAME
416 output git reset --hard $HEAD &&
421 comment_for_reflog skip
424 test -d "$DOTEST" || die "No interactive rebase running"
426 output git reset --hard && do_rest
431 STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
440 # we use merge anyway
443 die "Interactive rebase uses merge, so $1 does not make sense"
448 -p|--preserve-merges)
459 die "Interactive rebase already started"
461 git var GIT_COMMITTER_IDENT >/dev/null ||
462 die "You need to set your committer info first"
464 comment_for_reflog start
469 ONTO=$(git rev-parse --verify "$2") ||
470 die "Does not point to a valid commit: $2"
475 require_clean_work_tree
479 output git show-ref --verify --quiet "refs/heads/$2" ||
480 die "Invalid branchname: $2"
481 output git checkout "$2" ||
482 die "Could not checkout $2"
485 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
486 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
488 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
490 test -z "$ONTO" && ONTO=$UPSTREAM
492 : > "$DOTEST"/interactive || die "Could not mark as interactive"
493 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
494 echo "detached HEAD" > "$DOTEST"/head-name
496 echo $HEAD > "$DOTEST"/head
497 echo $UPSTREAM > "$DOTEST"/upstream
498 echo $ONTO > "$DOTEST"/onto
499 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
500 test t = "$VERBOSE" && : > "$DOTEST"/verbose
501 if test t = "$PRESERVE_MERGES"
503 # $REWRITTEN contains files for each commit that is
504 # reachable by at least one merge base of $HEAD and
505 # $UPSTREAM. They are not necessarily rewritten, but
506 # their children might be.
507 # This ensures that commits on merged, but otherwise
508 # unrelated side branches are left alone. (Think "X"
509 # in the man page's example.)
510 mkdir "$REWRITTEN" &&
511 for c in $(git merge-base --all $HEAD $UPSTREAM)
513 echo $ONTO > "$REWRITTEN"/$c ||
514 die "Could not init rewritten commits"
518 MERGES_OPTION=--no-merges
521 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
522 SHORTHEAD=$(git rev-parse --short $HEAD)
523 SHORTONTO=$(git rev-parse --short $ONTO)
524 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
525 --abbrev=7 --reverse --left-right --cherry-pick \
526 $UPSTREAM...$HEAD | \
527 sed -n "s/^>/pick /p" > "$TODO"
528 cat >> "$TODO" << EOF
530 # Rebase $SHORTUPSTREAM..$SHORTHEAD onto $SHORTONTO
534 # edit = use commit, but stop for amending
535 # squash = use commit, but meld into previous commit
537 # If you remove a line here THAT COMMIT WILL BE LOST.
538 # However, if you remove everything, the rebase will be aborted.
542 has_action "$TODO" ||
543 die_abort "Nothing to do"
545 cp "$TODO" "$TODO".backup
546 git_editor "$TODO" ||
547 die "Could not execute editor"
549 has_action "$TODO" ||
550 die_abort "Nothing to do"
552 output git checkout $ONTO && do_rest